HORIZON HASKELLDocslts/ghc-9.10.x248f8f02026-10-05Search names, modules, packages, or :: a typeCtrl K

GHC 9.10.3 · lts/ghc-9.10.x · 248f8f0 · 2026-10-05

Modulehttp-client-0.7.19Haskell2010

Network.HTTP.Client

Simpler API

The API below is rather low-level. The Network.HTTP.Simple module (from the http-conduit package) provides a higher-level API with built-in support for things like JSON request and response bodies. For most users, this will be an easier place to start. You can read the tutorial at:

https://github.com/snoyberg/http-client/blob/master/TUTORIAL.md

Lower-level API

This is the main entry point for using http-client. Used by itself, this module provides low-level access for streaming request and response bodies, and only non-secure HTTP connections. Helper packages such as http-conduit provide higher level streaming approaches, while other helper packages like http-client-tls provide secure connections.

There are three core components to be understood here: requests, responses, and managers. A Manager keeps track of open connections to various hosts, and when requested, will provide either an existing open connection or create a new connection on demand. A Manager also automatically reaps connections which have been unused for a certain period of time. A Manager allows for more efficient HTTP usage by allowing for keep-alive connections. Secure HTTP connections can be allowed by modifying the settings used for creating a manager. The simplest way to create a Manager is with:

newManager defaultManagerSettings

While generally speaking it is a good idea to share a single Manager throughout your application, there are cases where it makes more sense to create and destroy Managers more frequently. As an example, if you have an application which will make a large number of requests to different hosts, and will never make more than one connection to a single host, then sharing a Manager will result in idle connections being kept open longer than necessary. In such a situation, it makes sense to use newManager before each new request, to avoid running out of file descriptors. (Note that the managerIdleConnectionCount setting mitigates the risk of leaking too many file descriptors.)

The next core component is a Request, which represents a single HTTP request to be sent to a specific server. Requests allow for many settings to control exact how they function, but usually the simplest approach for creating a Request is to use parseRequest.

Finally, a Response is the result of sending a single Request to a server, over a connection which was acquired from a Manager. Note that you must close the response when you're done with it to ensure that the connection is recycled to the Manager to either be used by another request, or to be reaped. Usage of withResponse will ensure that this happens automatically.

Helper packages may provide replacements for various recommendations listed above. For example, if using http-client-tls, instead of using defaultManagerSettings, you would want to use tlsManagerSettings. Be sure to read the relevant helper library documentation for more information.

A note on exceptions: for the most part, all actions that perform I/O should be assumed to throw an HttpException in the event of some problem, and all pure functions will be total. For example, withResponse, httpLbs, and BodyReader can all throw exceptions. Functions like responseStatus and applyBasicAuth are guaranteed to be total (or there's a bug in the library).

One thing to be cautioned about: the type of parseRequest allows it to work in different monads. If used in the IO monad, it will throw an exception in the case of an invalid URI. In addition, if you leverage the IsString instance of the Request value via OverloadedStrings, an invalid URI will result in a partial value. Caveat emptor!

  • 18 types
  • 1 class
  • 112 values

Example Usage

Making a GET request
import Network.HTTP.Client
import Network.HTTP.Types.Status (statusCode)

main :: IO ()
main = do
  manager <- newManager defaultManagerSettings

  request <- parseRequest "http://httpbin.org/get"
  response <- httpLbs request manager

  putStrLn $ "The status code was: " ++ (show $ statusCode $ responseStatus response)
  print $ responseBody response
Posting JSON to a server
{-# LANGUAGE OverloadedStrings #-}
import Network.HTTP.Client
import Network.HTTP.Types.Status (statusCode)
import Data.Aeson (object, (.=), encode)
import Data.Text (Text)

main :: IO ()
main = do
  manager <- newManager defaultManagerSettings

  -- Create the request
  let requestObject = object ["name" .= "Michael", "age" .= 30]
  let requestObject = object
       [ "name" .= ("Michael" :: Text)
       , "age"  .= (30 :: Int)
       ]

  initialRequest <- parseRequest "http://httpbin.org/post"
  let request = initialRequest { method = "POST", requestBody = RequestBodyLBS $ encode requestObject }

  response <- httpLbs request manager
  putStrLn $ "The status code was: " ++ (show $ statusCode $ responseStatus response)
  print $ responseBody response

Performing requests

5 declarations
valuewithResponse :: Request -> Manager -> (Response BodyReader -> IO a) -> IO a
#

Perform a Request using a connection acquired from the given Manager, and then provide the Response to the given function. This function is fully exception safe, guaranteeing that the response will be closed when the inner function exits. It is defined as:

withResponse req man f = bracket (responseOpen req man) responseClose f

It is recommended that you use this function in place of explicit calls to responseOpen and responseClose.

You will need to use functions such as brRead to consume the response body.

Since 0.1.0

A convenience wrapper around withResponse which reads in the entire response body and immediately closes the connection. Note that this function performs fully strict I/O, and only uses a lazy ByteString in its response for memory efficiency. If you are anticipating a large response body, you are encouraged to use withResponse and brRead instead.

Since 0.1.0

The most low-level function for initiating an HTTP request.

The first argument to this function gives a full specification on the request: the host to connect to, whether to use SSL, headers, etc. Please see Request for full details. The second argument specifies which Manager should be used.

This function then returns a Response with a BodyReader. The Response contains the status code and headers that were sent back to us, and the BodyReader contains the body of the request. Note that this BodyReader allows you to have fully interleaved IO actions during your HTTP download, making it possible to download very large responses in constant memory.

An important note: the response body returned by this function represents a live HTTP connection. As such, if you do not use the response body, an open socket will be retained indefinitely. You must be certain to call responseClose on this response to free up resources.

This function automatically performs any necessary redirects, as specified by the redirectCount setting.

When implementing a (reverse) proxy using this function or relating functions, it's wise to remove Transfer-Encoding:, Content-Length:, Content-Encoding: and Accept-Encoding: from request and response headers to be relayed.

Since 0.1.0

valueresponseClose :: Response a -> IO ()
#

Close any open resources associated with the given Response. In general, this will either close an active Connection or return it to the Manager to be reused.

Since 0.1.0

Tracking redirect history

datadata HistoriedResponse body
#

A datatype holding information on redirected requests and the final response.

Since 0.4.1

Instances6Functor, Foldable, Traversable, Show, Generic, Rep

Connection manager

5 declarations
datadata Manager
#

Keeps track of open connections for keep-alive.

If possible, you should share a single Manager between multiple threads and requests.

Since 0.1.0

Instances1HasHttpManager

Create a Manager. The Manager will be shut down automatically via garbage collection.

Creating a new Manager is a relatively expensive operation, you are advised to share a single Manager between requests instead.

The first argument to this function is often defaultManagerSettings, though add-on libraries may provide a recommended replacement.

Since 0.1.0

valuecloseManager :: Manager -> IO ()
#

Deprecated. Manager will be closed for you automatically when no longer in use

Close all connections in a Manager.

Note that this doesn't affect currently in-flight connections, meaning you can safely use it without hurting any queries you may have concurrently running.

Since 0.1.0

Connection manager settings

Default value for ManagerSettings.

Note that this value does not have support for SSL/TLS. If you need to make any https connections, please use the http-client-tls package, which provides a tlsManagerSettings value.

Since 0.1.0

Exceptions for which we should retry our request if we were reusing an already open connection. In the case of IOExceptions, for example, we assume that the connection was closed on the server and therefore open a new one.

Since 0.1.0

valuemanagerWrapException :: ManagerSettings -> forall a. Request -> IO a -> IO a
#

Action wrapped around all attempted Requests, usually used to wrap up exceptions in library-specific types.

Default: wrap all IOExceptions in the InternalException constructor.

Total number of idle connection to keep open at a given time.

This limit helps deal with the case where you are making a large number of connections to different hosts. Without this limit, you could run out of file descriptors. Additionally, it can be set to zero to prevent reuse of any connections. Doing this is useful when the server your application is talking to sits behind a load balancer.

Default: 512

Since 0.3.7

Manager proxy settings

newtypenewtype ProxyOverride
#

How the HTTP proxy server settings should be discovered.

Since 0.4.7

valuenoProxy :: ProxyOverride
#

Never connect using a proxy, regardless of the proxy value in the Request.

Since 0.4.7

valueproxyEnvironment
  1. :: Maybe Proxy

    fallback if no environment set

  2. -> ProxyOverride
#

Get the proxy settings from the default environment variable (http_proxy for insecure, https_proxy for secure). If no variable is set, then fall back to the given value. Nothing is equivalent to noProxy, Just is equivalent to useProxy.

Since 0.4.7

The default proxy settings for a manager. In particular: if the http_proxy (or https_proxy) environment variable is set, use it. Otherwise, use the values in the Request.

Since 0.4.7

Response timeouts

datadata ResponseTimeout
#

How to deal with timing out on retrieval of response headers.

Instances2Eq, Show

Helpers

Request

15 declarations

The way you parse string of characters to construct a Request will determine whether exceptions will be thrown on non-2XX response status codes. This is because the behavior is controlled by a setting in Request itself (see checkResponse) and different parsing functions set it to different IO actions.

valueparseRequest :: MonadThrow m => String -> m Request
#

Convert a URL into a Request.

This function defaults some of the values in Request, such as setting method to GET and requestHeaders to [].

Since this function uses MonadThrow, the return monad can be anything that is an instance of MonadThrow, such as IO or Maybe.

You can place the request method at the beginning of the URL separated by a space, e.g.:

parseRequest "POST http://httpbin.org/post"

Note that the request method must be provided as all capital letters.

A Request created by this function won't cause exceptions on non-2XX response status codes.

To create a request which throws on non-2XX status codes, see parseUrlThrow

Add a Basic Auth header (with the specified user name and password) to the given Request. Ignore error handling:

 applyBasicAuth "user" "pass" $ parseRequest_ url

NOTE: The function applyDigestAuth is provided by the http-client-tls package instead of this package due to extra dependencies. Please use that package if you need to use digest authentication.

Since 0.1.0

Request type and fields

datadata Request
#

All information on how to connect to a host and what should be sent in the HTTP request.

If you simply wish to download from a URL, see parseRequest.

The constructor for this data type is not exposed. Instead, you should use either the defaultRequest value, or parseRequest to construct from a URL, and then use the records below to make modifications. This approach allows http-client to add configuration options without breaking backwards compatibility.

For example, to construct a POST request, you could do something like:

initReq <- parseRequest "http://www.example.com/path"
let req = initReq
            { method = "POST"
            }

For more information, please see http://www.yesodweb.com/book/settings-types.

Since 0.1.0

Instances2Show, IsString
valuehost :: Request -> ByteString
#

Requested host name, used for both the IP address to connect to and the host request header.

This is in URI format, with raw IPv6 addresses enclosed in square brackets. Use strippedHostName when making network connections.

Since 0.1.0

valueport :: Request -> Int
#

The port to connect to. Also used for generating the host request header.

Since 0.1.0

Custom HTTP request headers

The Content-Length and Transfer-Encoding headers are set automatically by this module, and shall not be added to requestHeaders.

If not provided by the user, Host will automatically be set based on the host and port fields.

Moreover, the Accept-Encoding header is set implicitly to gzip for convenience by default. This behaviour can be overridden if needed, by setting the header explicitly to a different value. In order to omit the Accept-Header altogether, set it to the empty string "". If you need an empty Accept-Header (i.e. requesting the identity encoding), set it to a non-empty white-space string, e.g. " ". See RFC 2616 section 14.3 for details about the semantics of the Accept-Header field. If you request a content-encoding not supported by this module, you will have to decode it yourself (see also the decompress field).

Note: Multiple header fields with the same field-name will result in multiple header fields being sent and therefore it's the responsibility of the client code to ensure that the rules from RFC 2616 section 4.2 are honoured.

Since 0.1.0

valuedecompress :: Request -> ByteString -> Bool
#

Predicate to specify whether gzipped data should be decompressed on the fly (see alwaysDecompress and browserDecompress). Argument is the mime type. Default: browserDecompress.

Since 0.1.0

valueredirectCount :: Request -> Int
#

How many redirects to follow when getting a resource. 0 means follow no redirects. Default value: 10.

Since 0.1.0

Check the response immediately after receiving the status and headers. This can be useful for throwing exceptions on non-success status codes.

In previous versions of http-client, this went under the name checkStatus, but was renamed to avoid confusion about the new default behavior (doing nothing).

Request body

datadata RequestBody
#

When using one of the RequestBodyStream / RequestBodyStreamChunked constructors, you must ensure that the GivesPopper can be called multiple times. Usually this is not a problem.

The RequestBodyStreamChunked will send a chunked request body. Note that not all servers support this. Only use RequestBodyStreamChunked if you know the server you're sending to supports chunked request bodies.

Since 0.1.0

Constructors

Instances3IsString, Semigroup, Monoid
typetype Popper = IO ByteString
#

A function which generates successive chunks of a request body, provider a single empty bytestring when no more data is available.

Since 0.1.0

typetype GivesPopper a = NeedsPopper a -> IO a
#

A function which will provide a Popper to a NeedsPopper. This seemingly convoluted structure allows for creation of request bodies which allocate scarce resources in an exception safe manner.

Since 0.1.0

Send a file as the request body.

It is expected that the file size does not change between calling streamFile and making any requests using this request body.

Since 0.4.9

Response

9 declarations
datadata Response body
#

A simple representation of the HTTP response.

Since 0.1.0

Instances4Functor, Foldable, Traversable, Show

Cookies set on the client after interacting with the server. If cookies have been disabled by setting cookieJar to Nothing, then this will always be empty.

Since 0.1.0

Response body

typetype BodyReader = IO ByteString
#

An IO action that represents an incoming response body coming from the server. Data provided by this action has already been gunzipped and de-chunked, and respects any content-length headers present.

The action gets a single chunk of data from the response body, or an empty bytestring if no more data is available.

Since 0.4.0

Get a single chunk of data from the response body, or an empty bytestring if no more data is available.

Note that in order to consume the entire request body, you will need to repeatedly call this function until you receive an empty ByteString as a result.

Since 0.1.0

Advanced connection creation

2 declarations

Misc

12 declarations
datadata HttpException
#

An exception which may be generated by this library

Constructors

Instances2Show, Exception
datadata HttpExceptionContent
#

Constructors

Instances1Show
valueequalCookie :: Cookie -> Cookie -> Bool
#

Instead of (==).

Since there was some confusion in the history of this library about how the Eq instance should work, it was removed for clarity, and replaced by equal and equiv. equal gives you equality of all fields of the Cookie record.

valueequivCookie :: Cookie -> Cookie -> Bool
#

Equality of name, domain, path only. This corresponds to step 11 of the algorithm described in Section 5.3 "Storage Model". See also: equal.

newtypenewtype CookieJar
#
Instances4Read, Show, Semigroup, Monoid
  • Read CookieJarDefined in http-client-0.7.19 · Network.HTTP.Client.Types
  • Show CookieJarDefined in http-client-0.7.19 · Network.HTTP.Client.Types
  • Semigroup CookieJarDefined in http-client-0.7.19 · Network.HTTP.Client.Types
  • Monoid CookieJarDefined in http-client-0.7.19 · Network.HTTP.Client.Types

    Since 1.9

datadata Proxy
#

Define a HTTP proxy, consisting of a hostname and port number.

Constructors

Instances4Eq, Ord, Read, Show
  • Eq ProxyDefined in http-client-0.7.19 · Network.HTTP.Client.Types
  • Ord ProxyDefined in http-client-0.7.19 · Network.HTTP.Client.Types
  • Read ProxyDefined in http-client-0.7.19 · Network.HTTP.Client.Types
  • Show ProxyDefined in http-client-0.7.19 · Network.HTTP.Client.Types
valuewithConnection :: Request -> Manager -> (Connection -> IO a) -> IO a
#

Perform an action using a Connection acquired from the given Manager.

You should use this only when you have to read and write interactively through the connection (e.g. connection by the WebSocket protocol).

strippedHostName takes a URI host name, as extracted by Network.URI.regName, and strips square brackets around IPv6 addresses.

The result is suitable for passing to services such as name resolution (Network.Socket.getAddr).

@since

Cookies

15 declarations
valuereceiveSetCookie
  1. :: SetCookie

    The SetCookie the cookie jar is receiving

  2. -> Request

    The request that originated the response that yielded the SetCookie

  3. -> UTCTime

    Value that should be used as "now"

  4. -> Bool

    Whether or not this request is coming from an "http" source (not javascript or anything like that)

  5. -> CookieJar

    Input cookie jar to modify

  6. -> CookieJar

    Updated cookie jar

#

This corresponds to the algorithm described in Section 5.3 "Storage Model" This function consists of calling generateCookie followed by insertCheckedCookie. Use this function if you plan to do both in a row. generateCookie and insertCheckedCookie are only provided for more fine-grained control.

valuegenerateCookie
  1. :: SetCookie

    The SetCookie we are encountering

  2. -> Request

    The request that originated the response that yielded the SetCookie

  3. -> UTCTime

    Value that should be used as "now"

  4. -> Bool

    Whether or not this request is coming from an "http" source (not javascript or anything like that)

  5. -> Maybe Cookie

    The optional output cookie

#

Turn a SetCookie into a Cookie, if it is valid

valueinsertCheckedCookie
  1. :: Cookie

    The SetCookie the cookie jar is receiving

  2. -> CookieJar

    Input cookie jar to modify

  3. -> Bool

    Whether or not this request is coming from an "http" source (not javascript or anything like that)

  4. -> CookieJar

    Updated (or not) cookie jar

#

Insert a cookie created by generateCookie into the cookie jar (or not if it shouldn't be allowed in)

valuecomputeCookieString
  1. :: Request

    Input request

  2. -> CookieJar

    Current cookie jar

  3. -> UTCTime

    Value that should be used as "now"

  4. -> Bool

    Whether or not this request is coming from an "http" source (not javascript or anything like that)

  5. -> (ByteString, CookieJar)

    (Contents of a "Cookie" header, Updated cookie jar (last-access-time is updated))

#

This corresponds to the algorithm described in Section 5.4 "The Cookie Header"

valuedomainMatches
  1. :: ByteString

    Domain to test

  2. -> ByteString

    Domain from a cookie

  3. -> Bool
#

This corresponds to the subcomponent algorithm entitled "Domain Matching" detailed in section 5.1.3